import pygame,sys,random

#pygameの初期化
pygame.init()

#変数定義
レフトフラグ=False #左向き状態を表す
アップフラグ=False #上向き状態を表す
シュートフラグ=False #ボールの形を表す
n=0 #シュートしたボールの形変更に使用
b=0 #ボールのコスチューム変更に使用
a=0 #ネコ1のコスチューム変更に使用

#スクリーンの作成
screen = pygame.display.set_mode((650,434))

#画像アップロード
背景=pygame.image.load("image\背景.png")
ネコ1_右=pygame.image.load("image\ネコ1.png")
ネコ1_右2=pygame.image.load("image\ネコ2.png")
ボール1=pygame.image.load("image\ボール1.png")
ボール2=pygame.image.load("image\ボール2.png")
ボール3=pygame.image.load("image\ボール3.png")

#ボールの変形処理
ボール4=pygame.transform.scale(ボール1,(45,10))

#壁データ
壁=[pygame.Rect(0,0,650,20), #ネコ1_rect⇒(280,180,-20,30)を参考に計算する
   pygame.Rect(0,0,20,434),
   pygame.Rect(630,0,-50,434),
   pygame.Rect(0,414,650,-30)]

#画像の加工
ネコ1_左=pygame.transform.flip(ネコ1_右,True,False)#オレンジネコ
ネコ1_左2=pygame.transform.flip(ネコ1_右2,True,False)#オレンジネコ

#コスチューム切り替え用のリスト
ネコ1リスト右=[ネコ1_右,ネコ1_右2]#オレンジネコ
ネコ1リスト左=[ネコ1_左,ネコ1_左2]#オレンジネコ
ボールリスト=[ボール1,ボール2,ボール3]

#画像の初期位置と大きさを定義
ネコ1_rect=pygame.Rect(280,180,-20,30)#オレンジネコ
ボール_rect=pygame.Rect(314,210,-30,-10)#ボール

#メイン処理
def main_proc():
    global レフトフラグ,アップフラグ,シュートフラグ
    global a,b,n
    #ネコ1の位置用変数
    cx=0
    cy=0
    bx=random.randint(5,50)
    by=random.randint(5,50)
    #カウント用
    n=n+1
    #ユーザからの入力を調べる
    key= pygame.key.get_pressed()
    #キーが押されたときの処理
    if key[pygame.K_RIGHT]:#右向矢印キーがおされた時
        cx=2 #ネコ1の移動量
        レフトフラグ=False
        a=a+1
              
    if key[pygame.K_LEFT]:#左向矢印キーがおされた時
        cx=-2 #ネコ1の移動量
        レフトフラグ=True
        a=a+1
        
    if key[pygame.K_UP]:#上向矢印キーがおされた時
        cy=-2 #ネコ1の移動量
        アップフラグ=True
        a=a+1
 
    if key[pygame.K_DOWN]:#下向矢印キーがおされた時
        cy=2 #ネコ1の移動量
        アップフラグ=False
        a=a+1

    if key[pygame.K_LSHIFT]:#左向矢印キーがおされた時
        ボール_rect.x=314
        ボール_rect.y=210

    #ネコ1の移動量
    ネコ1_rect.x = ネコ1_rect.x +cx 
    ネコ1_rect.y = ネコ1_rect.y +cy
    #ボールの衝突
    #ネコ1が左から衝突
    if ボール_rect.colliderect(ネコ1_rect) and レフトフラグ==True:
        if key[pygame.K_SPACE]: #シュート
            ボール_rect.x = ボール_rect.x-bx*3
            b=b+1
            シュートフラグ=True
        else: #ドリブル
            ボール_rect.x = ボール_rect.x +bx*-1
            b=b+1
        
    #ネコ1が右から衝突    
    if ボール_rect.colliderect(ネコ1_rect) and レフトフラグ==False:
        if key[pygame.K_SPACE] : #シュート
            ボール_rect.x = ボール_rect.x+bx*3
            b=b+1
            シュートフラグ=True
        else: #ドリブル
            ボール_rect.x = ボール_rect.x +bx
            b=b+1

    #ネコ1が上から衝突
    if ボール_rect.colliderect(ネコ1_rect) and アップフラグ==True:
        ボール_rect.y = ボール_rect.y -by
        b=b+1
        
    #ネコ1が下から衝突
    if ボール_rect.colliderect(ネコ1_rect) and アップフラグ==False:
        ボール_rect.y = ボール_rect.y +by
        b=b+1

    #ボール(シュート)の描画
    if シュートフラグ==True:
        if レフトフラグ==True:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ボール4,ボール_rect)
            screen.blit(ネコ1リスト左[a%2],ネコ1_rect)
        else:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ボール4,ボール_rect)
            screen.blit(ネコ1リスト右[a%2],ネコ1_rect)
    elif シュートフラグ==False:
        if レフトフラグ==True:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ボールリスト[b%3],ボール_rect)
            screen.blit(ネコ1リスト左[a%2],ネコ1_rect)
        else:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ボールリスト[b%3],ボール_rect)
            screen.blit(ネコ1リスト右[a%2],ネコ1_rect)

    #ボールの形が戻る時間の調整用
    if n%60==0:
        シュートフラグ=False

    #ボールとネコ1が壁にぶつかったときの処理
    if ボール_rect.collidelist(壁) !=-1:
        ボール_rect.x=314
        ボール_rect.y=210
    elif ネコ1_rect.collidelist(壁) !=-1:
        ネコ1_rect.x = ネコ1_rect.x -cx 
        ネコ1_rect.y = ネコ1_rect.y -cy
        
#ループ
while True:
    main_proc()
    #ディスプレイのアップデート
    pygame.display.update()
    
    #閉じるボタンの処理
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()

