import pygame,sys,random

#pygameの初期化
pygame.init()

#変数定義
レフトフラグ=False #左向き状態を表す
アップフラグ=False #上向き状態を表す
n=0 #カウント用
b=0 #ボールのコスチューム

#スクリーンの作成
screen = pygame.display.set_mode((650,434))

#画像アップロード
背景=pygame.image.load("image\背景.png")
ネコ1_右=pygame.image.load("image\ネコ1.png")
ネコ2_右=pygame.image.load("image\ネコ2.png")
ボール1=pygame.image.load("image\ボール1.png")
ボール2=pygame.image.load("image\ボール2.png")
ボール3=pygame.image.load("image\ボール3.png")

#画像の加工
ネコ1_左=pygame.transform.flip(ネコ1_右,True,False)
ネコ2_左=pygame.transform.flip(ネコ2_右,True,False)

#コスチューム切り替え用のリスト
ネコリスト右=[ネコ1_右,ネコ2_右]
ネコリスト左=[ネコ1_左,ネコ2_左]
ボールリスト=[ボール1,ボール2,ボール3]

#画像の初期位置と大きさを定義
ネコ_rect=pygame.Rect(280,180,-20,30)
ボール_rect=pygame.Rect(314,210,-30,-10)

#最初の一回目の表示
#※これがないと矢印キーが押されるまで何もでなくなる
screen.blit(背景,(0,0,0,0))
screen.blit(ネコリスト右[0],ネコ_rect)
screen.blit(ボール1,ボール_rect)

#メイン処理
def main_proc():
    global レフトフラグ,アップフラグ,n,b
    #ネコの位置用変数
    cx=0
    cy=0
    bx=random.randint(5,50)
    by=random.randint(5,100)
    #カウント用
    n=n+1
    #ユーザからの入力を調べる
    key= pygame.key.get_pressed()
    #キーが押されたときの処理
    if key[pygame.K_RIGHT]:#右向矢印キーがおされた時
        cx=2 #ネコの移動量
        レフトフラグ=False
        screen.blit(背景,(0,0,0,0))
        screen.blit(ネコリスト右[n%2],ネコ_rect)
        
    if key[pygame.K_LEFT]:#左向矢印キーがおされた時
        cx=-2 #ネコの移動量
        レフトフラグ=True
        screen.blit(背景,(0,0,0,0))
        screen.blit(ネコリスト左[n%2],ネコ_rect)
        
    if key[pygame.K_UP]:#上向矢印キーがおされた時
        cy=-2 #ネコの移動量
        アップフラグ=True
        if レフトフラグ==True:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ネコリスト左[n%2],ネコ_rect)
        else:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ネコリスト右[n%2],ネコ_rect)
 
    if key[pygame.K_DOWN]:#下向矢印キーがおされた時
        cy=2 #ネコの移動量
        アップフラグ=False
        if レフトフラグ==True:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ネコリスト左[n%2],ネコ_rect)
        else:
            screen.blit(背景,(0,0,0,0))
            screen.blit(ネコリスト右[n%2],ネコ_rect)
   
    #ネコの移動量
    ネコ_rect.x = ネコ_rect.x +cx 
    ネコ_rect.y = ネコ_rect.y +cy

    #ボールの衝突
    #ネコが左から衝突
    if ボール_rect.colliderect(ネコ_rect) and レフトフラグ==True:
        ボール_rect.x = ボール_rect.x +bx*-1
        b=b+1
        
    #ネコが右から衝突    
    if ボール_rect.colliderect(ネコ_rect) and レフトフラグ==False:
        ボール_rect.x = ボール_rect.x +bx
        b=b+1
        
    #ネコが上から衝突
    if ボール_rect.colliderect(ネコ_rect) and アップフラグ==True:
        ボール_rect.y = ボール_rect.y -by
        b=b+1
        
    #ネコが下から衝突
    if ボール_rect.colliderect(ネコ_rect) and アップフラグ==False:
        ボール_rect.y = ボール_rect.y +by
        b=b+1
        
    #ボールの描画   
    screen.blit(ボールリスト[b%3],ボール_rect)
    
#ループ
while True:
    main_proc()
    #ディスプレイのアップデート
    pygame.display.update()
    
    #閉じるボタンの処理
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()

